// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UEdGraphNode.h"
#include "ISCW_UEdGraphPin.h"
#include <memory>

using std::shared_ptr;

namespace Sourcify
{
	class ISCW_UClass;
	class ISCW_UK2Node : public virtual ISCW_UEdGraphNode
	{
	public:
		virtual ~ISCW_UK2Node() = default;

		virtual shared_ptr<ISCW_UClass> GetBlueprintClassFromNode() const = 0;

		virtual ISCW_UEdGraphPinPtr GetExecPin() const = 0;

		virtual ISCW_UEdGraphPinPtr GetThenPin() const = 0;
	};

	using ISCW_UK2NodeConstPtr = shared_ptr<const ISCW_UK2Node>;
	using ISCW_UK2NodePtr = shared_ptr<ISCW_UK2Node>;
} // namespace Sourcify